stack-1.4.0: The Haskell Tool Stack

Safe Haskell | None
Language | Haskell2010

Control.Concurrent.Execute

# Documentation

data ActionType #

Constructors

ATBuild |
ATBuildFinal |
ATFinal |

Instances

Eq ActionType # |
Methods (==) :: ActionType -> ActionType -> Bool # (/=) :: ActionType -> ActionType -> Bool #
Ord ActionType # |
Methods compare :: ActionType -> ActionType -> Ordering # (<) :: ActionType -> ActionType -> Bool # (<=) :: ActionType -> ActionType -> Bool # (>) :: ActionType -> ActionType -> Bool # (>=) :: ActionType -> ActionType -> Bool # max :: ActionType -> ActionType -> ActionType # min :: ActionType -> ActionType -> ActionType #
Show ActionType # |
Methods showsPrec :: Int -> ActionType -> ShowS # show :: ActionType -> String # showList :: [ActionType] -> ShowS #

data ActionId #

Constructors

ActionId !PackageIdentifier !ActionType |

Instances

Eq ActionId # |
Methods (==) :: ActionId -> ActionId -> Bool # (/=) :: ActionId -> ActionId -> Bool #
Ord ActionId # |
Methods compare :: ActionId -> ActionId -> Ordering # (<) :: ActionId -> ActionId -> Bool # (<=) :: ActionId -> ActionId -> Bool # (>) :: ActionId -> ActionId -> Bool # (>=) :: ActionId -> ActionId -> Bool # max :: ActionId -> ActionId -> ActionId # min :: ActionId -> ActionId -> ActionId #
Show ActionId # |
Methods showsPrec :: Int -> ActionId -> ShowS # show :: ActionId -> String # showList :: [ActionId] -> ShowS #

data ActionContext #

Constructors

ActionContext |
Fields acRemaining :: !(Set ActionId) Does not include the current action acDownstream :: [Action] Actions which depend on the current action

data Action #

Constructors

Action |
Fields actionId :: !ActionId actionDeps :: !(Set ActionId) actionDo :: !(ActionContext -> IO ())

runActions #

Arguments

:: Int | threads
-> Bool | keep going after one task has failed
-> Bool | run final actions concurrently?
-> [Action] |
-> (TVar Int -> IO ()) | progress updated
-> IO [SomeException] |